#Copyright (C) 2005 by Dr. Dieter Maurer <dieter@handshake.de> -- see LICENSE.txt
#       $Id: MonkeyPatch.py,v 1.1 2005/05/27 10:21:52 dieter Exp $
'''Patch Pythons standard library.

To make access to 'pypackage' URLs transparent.
'''

import pypackage, path, os, __builtin__, glob
from util import patch, unpatch


_patched = False

def patchPython():
    '''patch Python for transparent access to 'pypackage' URLs.'''
    global _patched
    if _patched: return
    _patched = True

    import urlparse, os, os.path, __builtin__, urllib
    if 'pypackage' not in urlparse.uses_relative:
        urlparse.uses_relative.append('pypackage')
    if 'pypackage' not in urlparse.uses_netloc:
        urlparse.uses_netloc.append('pypackage')
    for attr in 'listdir stat'.split(): patch(os, attr, pypackage)
    for attr in path._newly_implemented: patch(os.path, attr, path)
    for attr in 'open execfile'.split(): patch(__builtin__, attr, pypackage)
    patch(glob, 'glob', pypackage)
    from ReuseUtils import rebindFunction
    opener = rebindFunction(urllib.URLopener.open_local_file,
                            url2pathname = lambda file: 'pypackage:' + file
                            )
    def open_pypackage(self, url, opener_=opener):
        return opener_(self, url)
    urllib.URLopener.open_pypackage = open_pypackage


def unpatchPython():
    '''for testing purposes.

    We do not undo the 'urlparse' and 'urllib' patches as they
    should not harm.
    '''
    global _patched
    unpatch(os, os.path, __builtin__, glob)
    _patched = False
